#-*- coding: utf-8 -*-
#
# perceptron_sonar_2.py

from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI 1ERE\100300 NSI IA PROJET\NSI_ML_PREPA_DEPART_ELEVES_ML_4'
chdir(path)

# Perceptron Algorithm on the Sonar Dataset
from random import seed
from random import randrange
from csv import reader

# Load a CSV file
def load_csv(filename):
	dataset = list()
	with open(filename, 'r') as file:
		csv_reader = reader(file)
		for row in csv_reader:
			if not row:
				continue
			dataset.append(row)
	return dataset

# Convert string column to float
def str_column_to_float(dataset, column):
	for row in dataset:
		row[column] = float(row[column].strip())

# Convert string column to integer
def str_column_to_int(dataset, column):
	class_values = [row[column] for row in dataset]
	unique = set(class_values)
	lookup = dict()
	for i, value in enumerate(unique):
		lookup[value] = i
	for row in dataset:
		row[column] = lookup[row[column]]
	return lookup




def impression_fold(dataset,lignes):
	'''
	Impression formatée de quelques lignes du dataset :
	
	Impression de quelques éléments du dataset
	------------------------------------------
						0        1        2                 58       59       60   
	Row numéro   1 :  0.04530  0.05230  0.08430    ....    0.00520  0.00440  1.00000     M
	Row numéro   2 :  0.02620  0.05820  0.10990    ....    0.00950  0.00780  1.00000     M
	Row numéro   3 :  0.01000  0.01710  0.06230    ....    0.00400  0.01170  1.00000     M
	Row numéro   4 :  0.07620  0.06660  0.04810    ....    0.01070  0.00940  1.00000     M
	Row numéro 205 :  0.05220  0.04370  0.01800    ....    0.00770  0.00310  0.00000     R
	Row numéro 206 :  0.03030  0.03530  0.04900    ....    0.00360  0.00480  0.00000     R
	
	'''
	colonne_debut=(0,1,2)
	colonne_fin=(58,59,60)
	
	print()
	print("Impression de quelques éléments du dataset")
	print("------------------------------------------")
	
	'''
	A compléter
	'''
			

## Test the Perceptron algorithm on the sonar dataset
seed(1)

# Chargement et préparation des données
filename = 'sonar.all-data.csv'
dataset = load_csv(filename)

# Conversion des mesures en float
for i in range(len(dataset[0])-1):
	str_column_to_float(dataset, i)
	
# Conversion des classifications en integer
str_column_to_int(dataset, len(dataset[0])-1)

# Impression de quelques éléments du dataset
impression_fold(dataset,[1,2,3,4,205,206])