#-*- coding: utf-8 -*-
#
# perceptron_sonar_4.py

from os import chdir
from os import listdir

# Se déplacer dans le dossier en cours si besoin
path = r'P:\PRO\USB\NSI\NSI 1ERE\100300 NSI IA PROJET\NSI_ML_PREPA_DEPART_ELEVES_ML_4'
chdir(path)

# Perceptron Algorithm on the Sonar Dataset
from random import seed
from random import randrange
from csv import reader

# Load a CSV file
def load_csv(filename):
	dataset = list()
	with open(filename, 'r') as file:
		csv_reader = reader(file)
		for row in csv_reader:
			if not row:
				continue
			dataset.append(row)
	return dataset

# Convert string column to float
def str_column_to_float(dataset, column):
	for row in dataset:
		row[column] = float(row[column].strip())

# Convert string column to integer
def str_column_to_int(dataset, column):
	class_values = [row[column] for row in dataset]
	unique = set(class_values)
	lookup = dict()
	for i, value in enumerate(unique):
		lookup[value] = i
	for row in dataset:
		row[column] = lookup[row[column]]
	return lookup


def impression_fold(dataset,lignes=None):
	'''
	Impression formatée de quelques lignes du dataset :
	
	Impression de quelques éléments du dataset
	------------------------------------------
						0        1        2                 58       59       60   
	Row numéro   1 :  0.04530  0.05230  0.08430    ....    0.00520  0.00440  1.00000     M
	Row numéro   2 :  0.02620  0.05820  0.10990    ....    0.00950  0.00780  1.00000     M
	Row numéro   3 :  0.01000  0.01710  0.06230    ....    0.00400  0.01170  1.00000     M
	Row numéro   4 :  0.07620  0.06660  0.04810    ....    0.01070  0.00940  1.00000     M
	Row numéro 205 :  0.05220  0.04370  0.01800    ....    0.00770  0.00310  0.00000     R
	Row numéro 206 :  0.03030  0.03530  0.04900    ....    0.00360  0.00480  0.00000     R
	
	'''
	colonne_debut=(0,1,2)
	colonne_fin=(58,59,60)
	
	# Si la liste lignes est vide alors on affiche toutes
	# les lignes du dataset donc on créé la liste lignes
	# en y mettant par une compréhension de liste tous les
	# numéros des lignes
	if lignes==None:
		lignes=[i for i in range(len(dataset))]
	
		
	print()
	print("Impression de quelques éléments du dataset")
	print("------------------------------------------")
	


			
def impression_fold_numerote(dataset,lignes=None):
	'''
	Impression formatée de quelques lignes du dataset_copy :
	
	Impression de quelques éléments du dataset
	------------------------------------------
						0        1        2                 58       59       60   
	Row numéro   1 :  0.04530  0.05230  0.08430    ....    0.00520  0.00440  1.00000     M
	Row numéro   2 :  0.02620  0.05820  0.10990    ....    0.00950  0.00780  1.00000     M
	Row numéro   3 :  0.01000  0.01710  0.06230    ....    0.00400  0.01170  1.00000     M
	Row numéro   4 :  0.07620  0.06660  0.04810    ....    0.01070  0.00940  1.00000     M
	Row numéro 205 :  0.05220  0.04370  0.01800    ....    0.00770  0.00310  0.00000     R
	Row numéro 206 :  0.03030  0.03530  0.04900    ....    0.00360  0.00480  0.00000     R
	
	'''
	colonne_debut=(1,2,3)
	colonne_fin=(60,61)

	# Si la liste lignes est vide alors on affiche toutes
	# les lignes du dataset donc on créé la liste lignes
	# en y mettant par une compréhension de liste tous les
	# numéros des lignes
	if lignes==None:
		lignes=[i for i in range(len(dataset))]
	
	print()
	print("Impression de quelques éléments du dataset_copy")
	print("-----------------------------------------------")






# Split a dataset into k folds
def cross_validation_split(datas, n_folds):
	'''
	Répartition du jeux d'échantillons dataset_copy en k folds
	dataset_copy n'est pas modifié. La fonction retourne une liste
	de folds contenant chacun fold_size échantillons de mesures.
	'''
	dataset_split = []

	# Calcul de la taille d'un fold
	fold_size = .............. / n_folds)
	
	# Création des folds
	for _ in range(n_folds):
		# Création d'un fold de la bonne taille
		fold = list()
		while len(fold) < ..............:
			index = randrange(len(datas))
			fold.append(datas.pop(index))
		
		# Ajout de ce fold à la liste des dataset_split
		dataset_split.append(................)
	
	# On retourne les k-folds datasets
	return dataset_split

## Test the Perceptron algorithm on the sonar dataset
seed(1)

# Chargement et prépaation des données
filename = 'sonar.all-data.csv'
dataset = load_csv(filename)

# Conversion des mesures en float
for i in range(len(dataset[0])-1):
	str_column_to_float(dataset, i)
	
# Convertion des classifications en integer
str_column_to_int(dataset, len(dataset[0])-1)

# Impression de quelques éléments du dataset
impression_fold(dataset,[1,2,3,4,205,206])


# Ajout d'une colonne en tête de chaque ligne du dataset
# pour y mettre le n° d'échantillon stocké dans dataset_copy
# pour préserver la liste initiale
dataset_copy = []
for row in range(len(dataset)):
	dataset_copy.append([row]+dataset[row])

# Impression de quelques éléments du dataset_copy	
impression_fold_numerote(dataset_copy,[1,2,3,4,205,206])

# Répartition en k groupes
n_folds = 25
folds = cross_validation_split(dataset_copy, n_folds)
impression_fold_numerote(folds[0])	